/******************************************************************************
 Keypad demo room, by Lars Skovlund
 Adapted from the SCI Template Game by Brian Provinciano
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
(include "keypad.sh")

/******************************************************************************/
(script 1)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "keypad")

/******************************************************************************/

(local kptxt[5])

(instance myKeyPad of DisplayKeypad
	(properties
		maxLength	4
		autoExit	FALSE
		script		0
		longestText	1	/* one character */
		color		clBLACK
		back		clWHITE
		x		20
		y		160
		requireMax	TRUE
	)

)

(instance key1 of KeypadButton
	(properties
		x	100
		y	100
		view	0
		loop 	0
		text	"1"
	)
)

(instance key2 of KeypadButton
	(properties
		x	120
		y	100
		view	0
		loop 	2
		text	"2"
	)
)

(instance key3 of KeypadButton
	(properties
		x	140
		y	100
		view	0
		loop 	1
		text	"3"
	)
)

(instance key4 of KeypadButton
	(properties
		x	160
		y	100
		view	0
		loop 	5
		special KEYPAD_SPECIAL_CANCEL
	)
)

(instance key5 of KeypadButton
	(properties
		x	180
		y	100
		view	0
		loop 	6
		special KEYPAD_SPECIAL_BKSP
	)
)

(instance key6 of KeypadButton
	(properties
		x	200
		y	100
		view	0
		loop 	3
		special KEYPAD_SPECIAL_ENTER
	)
)

(instance public rm001 of Rm
	(properties
		picture scriptNumber
		// Set up the rooms to go to/come from here
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		// same in every script, starts things up
  		(super:init())
  		(self:setScript(RoomScript))
  		
  		// Check which room ego came from and position it
  		(switch(gPreviousRoomNumber)
            /******************************************************
             * Put the cases here for the rooms ego can come from *
             ******************************************************/
  			(default
  				(send gEgo:
  					posn(220 130)
  					loop(1)
  				)
  			)
  		)
		
		// Set up the ego
		SetUpEgo()		
		(send gEgo:init())

        /****************************************
         * Set up the room's music to play here *
         ****************************************/ /*
		(send gTheMusic:
			prevSignal(0)
			stop()
			number(scriptNumber)
			loop(-1)
			play()
		)*/

		(myKeyPad:setScript(KeypadScript) outputString(@kptxt)
			  init(key1 key2 key3 key4 key5 key6))

        /**************************************************
         * Add the rest of your initialization stuff here *
         **************************************************/
  )
)

/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
	(if (Said('look/keypad'))
		(myKeyPad:init() show()) /* The init ensures that the keypad can be used any number of times. */
		(send pEvent:claimed(TRUE))
		)
	)
)
/******************************************************************************/

(instance KeypadScript of Script
	(properties)
	(method (changeState newState)
		(super:changeState(newState))
		(switch (newState)
			(case KEYPAD_DONE_STATE ((send client:hide(FALSE)) 
						  FormatPrint("You typed: %s" @kptxt)))
			(case KEYPAD_ERROR_STATE (FormatPrint("You need to type %d characters" (send client:maxLength()))))
		)
	)
)
